//+------------------------------------------------------------------+
//|                                                       AFIRMA.mq5 |
//|                                                                  |
//|                                          Copyright  2006, gpwr. |
//+------------------------------------------------------------------+
//---  
#property copyright "Copyright  2006, gpwr."
#property link      ""
//---   
#property version   "1.01"
//---     
#property indicator_chart_window 
//---        
#property indicator_buffers 2
//---     
#property indicator_plots   2
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET 0
#define pi 3.141592653589793238462643383279502884197169399375105820974944592
//+----------------------------------------------+
//|     1            |
//+----------------------------------------------+
//---   1   
#property indicator_type1   DRAW_LINE
//---      1   BlueViolet
#property indicator_color1  BlueViolet
//---   1 -  
#property indicator_style1  STYLE_SOLID
//---    1  2
#property indicator_width1  2
//---    
#property indicator_label1  "FIRMA"
//+----------------------------------------------+
//|     2            |
//+----------------------------------------------+
//---   2   
#property indicator_type2   DRAW_LINE
//---      2   Red
#property indicator_color2  Red
//---   2 -  
#property indicator_style2  STYLE_SOLID
//---    2  2
#property indicator_width2  2
//---    
#property indicator_label2  "ARMA"
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
enum ENUM_WINDOWS   //  
  {
   Rectangular = 1, // Rectangular window
   Hanning1,        // Hanning window 1
   Hanning2,        // Hanning window 2
   Blackman,        // Blackman window
   Blackman_Harris  // Blackman-Harris window
  };
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input int  Periods = 4;               //     1/(2*Periods)
input int  Taps    = 21;              //     
input ENUM_WINDOWS Window=Blackman;   //  
input int Shift=0;                    //       
//+----------------------------------------------+
//---      
int min_rates_total;
//---   
int n;
double w[],wsum,sx2,sx3,sx4,sx5,sx6,den;
//---   ,   
//---      
double FIRMABuffer[],ARMABuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//---    
   ArrayResize(w,Taps);
   wsum=0.0;
   for(int k=0; k<Taps; k++)
     {
      switch(Window)
        {
         case Rectangular: w[k]=1.0; break; // Rectangular window       
         case Hanning1: w[k]=0.50-0.50*MathCos(2.0*pi*k/Taps); break;  // Hanning window
         case Hanning2: w[k]=0.54-0.46*MathCos(2.0*pi*k/Taps); break;  // Hamming window
         case Blackman: w[k]=0.42-0.50*MathCos(2.0*pi*k/Taps)+0.08*MathCos(4.0*pi*k/Taps); break; // Blackman window
         case Blackman_Harris: w[k]=0.35875-0.48829*MathCos(2.0*pi*k/Taps)+0.14128
            *MathCos(4.0*pi*k/Taps)-0.01168*MathCos(6.0*pi*k/Taps); // Blackman - Harris window
        }
      if(k!=Taps/2.0) w[k]=w[k]*MathSin(pi*(k-Taps/2.0)/Periods)/pi/(k-Taps/2.0);
      wsum+=w[k];
     }
//--- calculate sums for the least-squares method
   n=(Taps-1)/2;
   sx2 = (2*n + 1) / 3.0;
   sx3 = n*(n + 1) / 2.0;
   sx4 = sx2*(3*n*n+3*n - 1) / 5.0;
   sx5 = sx3*(2*n*n+2*n - 1) / 3.0;
   sx6 = sx2*(3*n*n*n*(n + 2) - 3*n+1) / 7.0;
   den = sx6*sx4 / sx5 - sx5;
//---     
   min_rates_total=Taps;
//---    FIRMABuffer[]   
   SetIndexBuffer(0,FIRMABuffer,INDICATOR_DATA);
//---    1    Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//---       1  min_rates_total
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---       
   ArraySetAsSeries(FIRMABuffer,true);
//---    ARMABuffer[]   
   SetIndexBuffer(1,ARMABuffer,INDICATOR_DATA);
//---    2    Shift
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift);
//---       2  min_rates_total+1
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---       
   ArraySetAsSeries(ARMABuffer,true);
//---      
   string shortname;
   StringConcatenate(shortname,"AFIRMA(",Periods,", ",Taps,", ",EnumToString(Window),", ",Shift,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//---
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const int begin,          //     
                const double &price[])    //     
  {
//---       
   if(rates_total<min_rates_total+begin) return(RESET);
//---    
   int limit,bar;
   double a0,a1,a2,a3,sx2y,sx3y,p,q;
//---    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      limit=rates_total-1-min_rates_total-begin; //      
      //---      
      PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total+begin);
      PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,rates_total-n-1);
     }
   else limit=rates_total-prev_calculated; //      
//---         
   ArraySetAsSeries(price,true);
//---     FIRMA
   for(bar=limit; bar>=0; bar--)
     {
      FIRMABuffer[bar+n]=0.0;
      for(int k=0; k<Taps; k++) FIRMABuffer[bar+n]+=price[bar+k]*w[k]/wsum;
     }
//---    
   for(bar=limit; bar>=0; bar--)
     {
      if(bar<n) FIRMABuffer[bar]=EMPTY_VALUE;
      ARMABuffer[bar]=EMPTY_VALUE;
     }
//--- calculate regressive MA for the remaining n bars
   a0 = FIRMABuffer[n];
   a1 = FIRMABuffer[n]-FIRMABuffer[n+1];
   sx2y = 0.0;
   sx3y = 0.0;
//---
   for(int i=0; i<=n; i++)
     {
      sx2y += i*i*price[n-i];
      sx3y += i*i*i*price[n-i];
     }
//---
   sx2y = 2.0*sx2y / n / (n + 1);
   sx3y = 2.0*sx3y / n / (n + 1);
   p = sx2y - a0*sx2 - a1*sx3;
   q = sx3y - a0*sx3 - a1*sx4;
   a2 = (p*sx6 / sx5 - q) / den;
   a3 = (q*sx4 / sx5 - p) / den;
//---
   for(int k=0; k<=n; k++) ARMABuffer[n-k]=a0+k*a1+k*k*a2+k*k*k*a3;
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
